<?php
	/*******************************************************
	* Only these origins will be allowed to upload images *
	******************************************************/
	$accepted_origins = array("http://localhost", "http://192.168.1.1", "http://example.com");

	/*********************************************
	* Change this line to set the upload folder *
	*********************************************/
	session_start();

	if (!isset($_SESSION['tinyMCE_medias'])) exit;

	$imageFolder = $_SESSION['tinyMCE_medias'];

	reset($_FILES);
	$temp = current($_FILES);
	if (is_uploaded_file($temp['tmp_name'])) {
		if (isset($_SERVER['HTTP_ORIGIN'])) {
			// same-origin requests won't set an origin. If the origin is set, it must be valid.
			if (in_array($_SERVER['HTTP_ORIGIN'], $accepted_origins)) {
				header('Access-Control-Allow-Origin: ' . $_SERVER['HTTP_ORIGIN']);
			} else {
				header("HTTP/1.0 403 Origin Denied");
				return;
			}
		}

		/*
		If your script needs to receive cookies, set images_upload_credentials : true in
		the configuration and enable the following two headers.
		*/
		// header('Access-Control-Allow-Credentials: true');
		// header('P3P: CP="There is no P3P policy."');

		// Sanitize input
		if (preg_match("/([^\w\s\d\-_~,;:\[\]\(\).])|([\.]{2,})/", $temp['name'])) {
			header("HTTP/1.0 500 Invalid file name.");
			return;
		}

		// Verify extension
		$ext = pathinfo($temp['name'], PATHINFO_EXTENSION);
		if (!in_array(strtolower($ext), array('gif', 'jpg', 'png', 'jpeg'))) {
			header("HTTP/1.0 500 Invalid extension.");
			return;
		}

		// Accept upload if there was no origin, or if it is an accepted origin
		if (! is_dir($imageFolder.'tinymce/'))
			mkdir($imageFolder.'tinymce/', 0777, true);
		$target = 'tinymce/'.date('Y-m-d_H-i-s').'.jpg';
		switch (exif_imagetype($temp['tmp_name'])) {
			case IMAGETYPE_PNG :
				$res = imagecreatefrompng($temp['tmp_name']);
				imageinterlace($res);
				if (imagejpeg($res, $imageFolder.$target))
					unlink($temp['tmp_name']);
				break;
			case IMAGETYPE_GIF :
				$res = imagecreatefromgif($temp['tmp_name']);
				imageinterlace($res);
				if (imagejpeg($res, $imageFolder.$target))
					unlink($temp['tmp_name']);
				break;
			default :
				move_uploaded_file($temp['tmp_name'], $imageFolder.$target);
		}
		// ".thumbs/" is defined by PlxMedias::__construct() in Pluxml
		$thumbnail = $imageFolder.'.thumbs/'.$target;
		if (file_exists($thumbnail))
			unlink($thumbnail);

		// Respond to the successful upload with JSON.
		// Use a location key to specify the path to the saved image resource.
		// { location : '/your/uploaded/image/file'}
		echo json_encode(array('location' =>$target));
	} else {
		// Notify editor that the upload failed
		header("HTTP/1.0 500 Server Error");
	}
?>
